@------check if the independent variables give correct size------@
/********this one is updated on 22 Sep 2005 **********/

new;
tb = hsec;
_prin = 0; /*0: do not print output, 1: print output*/

/*output file = tables/sizebrknew.out on;*/
_k = {1,3,12,24};
_k={24};
_kall=_k;/**/
test="standols"$|"trueDGP"$|"extremreg"$|"volk"$|"sign"$|"signrank";  /* choices are volk, sign, signrank, standols, extremreg, trueDGP*/
test="longhor";
test="volk"$|"ces";
test="standols"$|"longhor"$|"volk"$|"sign"$|"signrank";
test="volk";
hor={1,10,30,50,70,110,130};

_m=1;
__output = 0;
/*spec = "longlag"; rearranged long horizon test, or longhor for general regression*/

#include proc/cowork2.prc;/**/
#include proc/stock.g;/**/

#include stock/campbell/LHREGHH.G;
#include stock/campbell/LHREGNW.G; 
#include stock/campbell/hachh.g;
#include stock/campbell/hacnw.g;/**/

#include proc/jab.prc;/**/
/*#include proc/ptv.src;*/
/*#include proc/ptv3.src;*/

load path=/share2/wei cvdf3_a;
cvdf_a=cvdf3_a[1,.]|sortc(cvdf3_a[2:rows(cvdf3_a),.],1);
clear cvdf3_a;

screen off;

cc2=seqa(-40,0.5,50); /*all c values*/
cc3=seqa(-15,0.2,100);
cc4=seqa(5,0.5,10);
cc = cc2|cc3|cc4;

/*cc=seqa(-40,1,50);
*/

ccvolk={-10,-5,-1,-0.5,0}; /*this is the version for Volkanov paper*/
dirname = "fmtall/fmtstop200/";
T = "200";
h1="two sided";

model = "brk"; /* choices are ar for AR(1), lm for long-memory, brk for stopbreak, mcbrk for Morkov break */
@***********************@

if model $== "ar";
/**********************************************************
load simulated data according to delt and persis
************************************************************/
/*delt = {0.1,0.5,0.9}; characterize the residual correlation*/
/*persis = {0.80,0.9,0.99}; represents the persistence of xt*/

delt = {-0.99,-0.9,-0.7,-0.3,0.3,0.7,0.9,0.99};
persis = {0.5,0.9,0.95,0.99};
/*
delt={-0.7,-0.1,0.1,0.9};
persis={0.1,0.5,0.8,0.9,0.99};
*/
elseif model $== "lm";
persis={0.4,0.5,0.7,0.8,0.9};
delt = {-0.3,-0.7,-0.9,-0.99,0.3,0.7,0.9,0.99};  /*based on experiments, this combination represents 
              case closest to the AR(1) case when delta = 0.9 and phi = 0.99*/
d = persis;

elseif model $== "brk";
/*
delt = 0.9;
/*delt = {0.1,0.5,0.9}; characterize the residual correlation*/
persis = 0.99;
/* persis = {0.80,0.9,0.99};represents the persistence of xt*/
level = 3;
*/

delt = {-0.99,-0.9,-0.7,-0.3,0.3,0.7,0.9,0.99};
/*delt = {0,0.3,0.7,0.9,0.99};*/
/*delt = {-0.99,-0.9,-0.7,-0.3,0,0.3,0.7,0.9,0.99}; characterize the residual correlation */
/*delt = {0.1,0.5,0.9}; characterize the residual correlation*/


dval = {0.4,0.5,0.7,0.9};
persis = dval;
/* persis = {0.80,0.9,0.99};represents the persistence of xt*/

elseif model$=="meanbrk";

/*
delt={-0.99,-0.9,-0.7,-0.3,0.3,0.7,0.9,0.99};
persis = {0.5,0.9,0.99};
*/
delt=0.9;
persis=0.5;

level=7;

elseif model$=="mcbrk";

delt={-0.9,-0.3,0.7,0.99};
persis={0.3,0.5,0.7,0.9};

endif;

tt=1;
do until tt>rows(test);


kk=1;
do until kk>rows(_k);
pfill2=0~persis';


for j (1,rows(delt),1);
pfill1=delt[j];
for jj (1, rows(persis),1);
pval1 = zeros(1,5);
if model $== "ar";
residis ="norm"; /*norm: for normal residual, tnu4: for t
                    residual with df. 4, normbrk: normal plus break*/
subdir = "fmtall/fmtar200/";

/*********************
using AR(1) data 
*********************/


/**********************************************************
load simulated data according to delt and persis
************************************************************/

ffmmt = ftos(delt[j]*100,"%*.*lf",1,0) $+ ftos(persis[jj]*100,"%*.*lf",2,0);

stname1 = "yt" $+ ffmmt;
stname2 = "xt" $+ ffmmt;

datadiry = subdir $+ stname1;
datadirx = subdir $+ stname2;

load ym = ^datadiry;
load xm = ^datadirx; 

/***********************************************************/
elseif model $== "lm";
/**************************
using long-memory data
***************************/

subdir = "fmtall/fmtlm200/";

ffmmt = ftos(delt[j]*100,"%*.*lf",1,0) $+"_"$+ ftos(d[jj]*10,"%*.*lf",1,0);
stname1 = "ytlm" $+ ffmmt;
stname2 = "xtlm" $+ ffmmt;

datadiry = subdir $+ stname1;
datadirx = subdir $+ stname2;

load ym = ^datadiry;
load xm = ^datadirx; 

/*ym = ym[901:rows(ym),.];
xm = xm[901:rows(xm),.];
*/
/***********************************************************/

elseif model $== "brk";
/**********************************************************
load simulated structural break data according to delt and persis and level
************************************************************/
/*
subdir = "d:/cowork2/longhor/fmt/"$+ T $+ "normbrk" $+"/";



*/

ffmmt = ftos(delt[j]*100,"%*.*lf",1,0) $+ ftos(persis[jj]*10,"%*.*lf",1,0);
stname1 = "ytstop" $+ ffmmt;
stname2 = "xtstop" $+ ffmmt;

datadiry = dirname $+ stname1;
datadirx = dirname $+ stname2;

load ym = ^datadiry;
load xm = ^datadirx; 

elseif model$=="meanbrk";

subdir="fmtall/meanbrk200/";

ffmmt = ftos(delt[j]*100,"%*.*lf",1,0) $+ ftos(persis[jj]*100,"%*.*lf",2,0) $+ ftos(level, "_%*.*lf",1,0);

stname1 = "ytsb" $+ ffmmt;
stname2 = "xtsb" $+ ffmmt;

datadiry = subdir $+ stname1;
datadirx = subdir $+ stname2;

load ym = ^datadiry;
load xm = ^datadirx; 

elseif model$== "mcbrk";

subdir="fmtall/fmtMC200/";

ffmmt = ftos(delt[j]*100,"%*.*lf",1,0) $+ ftos(persis[jj]*10,"%*.*lf",1,0);
stname1 = "ytMC" $+ ffmmt;
stname2 = "xtMC" $+ ffmmt;

datadiry = subdir $+ stname1;
datadirx = subdir $+ stname2;

load ym = ^datadiry;
load xm = ^datadirx; 


endif;


/****************************************************************
 **                    set up relation btw yt and xt
**************************************************************/
coeff=0;
/*coeff={-0.1 -0.03 0 0.03 0.07 0.1};*/
/*coeff = {-0.1 -0.07 -0.03 0 0.03 0.05 0.07 0.1 0.12};  for n = 100, it is {0 0.07 0.1}, n = 200, it is {0 0.03 0.05} */
predit =seqa(0,1,cols(coeff)); /* 0: no forecast, 1: weak forecast, 2: stronger forecast*/


/*
if predit == 0;
yt = ym[2:rows(ym),.];
xt = xm[1:rows(xm)-1,.];
else;
*/
subbeg = 1;
subn = 2000; /*the # of repeat */

for aa (1,rows(predit),1);
yt = ym[2:rows(ym),subbeg:subn]+coeff[predit[aa]+1].*xm[1:rows(xm)-1,subbeg:subn];
xt = xm[1:rows(xm)-1,subbeg:subn];
/*endif; */
/**********************************************************/



/**************************************************************
**  standard regression test procedures
***************************************************************/
a = 0.025;  /*nominal size*/
tcri = cdfni(a);
tbols = zeros(1,cols(xt));
tblh=zeros(1,cols(xt));
tbhac=zeros(1,cols(xt));
_m = zeros(rows(_k[kk]),1);


if test[tt]$=="volk";
  volktype="sup";  /*choices are sup, bonfadj*/
for i (1,cols(tbols),1);

  
/**** select the right critical value matrix*******/
maxp = 10;  /* largest lag in BIC in first stage*/
/*cim = (0.99-1)*strtof(T);*/
{pstar,junk}=urbic(xt[.,i],1,maxp+1);
{aat,junk}=adf(xt[.,i],1,pstar);

{cim}=unitci(aat[2,1],0.0,cvdf_a);
_olsres=1;
{ vnam,m,b,stb,vc,stderr,sigma,cx,rsq,resid,dwstat } 
= ols(0,yt[.,i],xt[.,i]);

r1 = xt[2:rows(xt),i]-(1+cim[1]/strtof(T))*xt[1:rows(xt)-1,i];
r2 = resid[1:rows(resid)-1]; 

{dhat,omega}=deltahat(r1,r2,1,rows(r2),maxp);
dhat=dhat[1,2];
dhat1=dhat;

/*---select and interpolate to get cv's-----*/
/* here we select the correct critical value matrices depending on delta
  and interpolate */

if dhat<=-0.95;aa1=-95;aa2=-95;dhat=10;
elseif dhat<-0.9;aa1=-95;aa2=-90;dhat=10;
elseif dhat<-0.8;aa1=-90;aa2=-80;dhat=10;
elseif dhat<-0.7;aa1=-80;aa2=-70;dhat=10;
elseif dhat<-0.6;aa1=-70;aa2=-60;dhat=10;
elseif dhat<-0.5;aa1=-60;aa2=-50;dhat=10;
elseif dhat<-0.4;aa1=-50;aa2=-40;dhat=10;
elseif dhat<-0.3;aa1=-40;aa2=-30;dhat=10;
elseif dhat<-0.2;aa1=-30;aa2=-20;dhat=10;
elseif dhat<-0.1;aa1=-20;aa2=-10;dhat=10;
elseif dhat<0;aa1=-10;aa2=0;dhat=10;/**/
elseif dhat<0.1;aa1=0;aa2=10;dhat=10;
elseif dhat<0.2;aa1=10;aa2=20;dhat=10;
elseif dhat<0.3;aa1=20;aa2=30;dhat=10;
elseif dhat<0.4;aa1=30;aa2=40;dhat=10;
elseif dhat<0.5;aa1=40;aa2=50;dhat=10;
elseif dhat<0.6;aa1=50;aa2=60;dhat=10;
elseif dhat<0.7;aa1=60;aa2=70;dhat=10;
elseif dhat<0.8;aa1=70;aa2=80;dhat=10;
elseif dhat<0.9;aa1=80;aa2=90;dhat=10;
elseif dhat<0.95;aa1=90;aa2=95;dhat=10;
else; aa1=95;aa2=95;
endif;



    

    if _k[kk]==1;
    
/*
fomat1 = "d:/cowork2/longhor/fmtall/ces3/"$+ftos(abs(aa1),"ces3_%*.*lf",1,0);
fomat2 = "d:/cowork2/longhor/fmtall/ces3/"$+ftos(abs(aa2),"ces3_%*.*lf",1,0);
*/
/*
fomat1 = "d:/cowork2/longhor/fmt700/"$+ftos(aa1,"volkcri%*.*lf",1,0);
fomat2 = "d:/cowork2/longhor/fmt700/"$+ftos(aa2,"volkcri%*.*lf",1,0);
*/
/*
fomat1 = "d:/cowork2/longhor/fmt1000trend/"$+ftos(abs(aa1),"volkcri%*.*lf",1,0);
fomat2 = "d:/cowork2/longhor/fmt1000trend/"$+ftos(abs(aa2),"volkcri%*.*lf",1,0);
*/
fomat1 = "fmtall/fmt1000/"$+ftos(abs(aa1),"volkcri%*.*lf",1,0)$+ftos(_k[kk],"_%*.*lf",1,0);
fomat2 = "fmtall/fmt1000/"$+ftos(abs(aa2),"volkcri%*.*lf",1,0)$+ftos(_k[kk],"_%*.*lf",1,0);
/*
fomat1 = "d:/cowork2/longhor/fmt1h/"$+ftos(abs(aa1),"volkcri_%*.*lf",1,0);
fomat2 = "d:/cowork2/longhor/fmt1h/"$+ftos(abs(aa2),"volkcri_%*.*lf",1,0);
*/

load vv1 = ^fomat1;
load vv2 = ^fomat2;

volcri = zeros(rows(vv1),cols(vv1));
crr = 1;

do until crr>rows(volcri);
  if aa1==aa2;
  volcri[crr,.]=vv1[crr,.];
  else;

  volcri[crr,.] = lint(abs(dhat1)*100,vv1[crr,.]|vv2[crr,.],abs(aa1)|abs(aa2));

  /*volcri[crr,.] = lint(dhat1*100,vv1[crr,.]|vv2[crr,.],aa1|aa2);*/
  endif;
crr=crr+1;
endo;

else;  /*if k\==1*/

h=_k[kk]/strtof(T)*1000;
h=fix(h);
indh=indnvle(h,hor);

fomat1 = "fmtall/fmt1000/"$+ftos(abs(aa1),"volkcri%*.*lf",1,0)$+ftos(hor[indh],"_%*.*lf",1,0);
fomat2 = "fmtall/fmt1000/"$+ftos(abs(aa2),"volkcri%*.*lf",1,0)$+ftos(hor[indh],"_%*.*lf",1,0);

fomat3 = "fmtall/fmt1000/"$+ftos(abs(aa1),"volkcri%*.*lf",1,0)$+ftos(hor[indh+1],"_%*.*lf",1,0);
fomat4 = "fmtall/fmt1000/"$+ftos(abs(aa2),"volkcri%*.*lf",1,0)$+ftos(hor[indh+1],"_%*.*lf",1,0);

load vv1 = ^fomat1;load vv2 = ^fomat2;
load vv3 = ^fomat3;load vv4 = ^fomat4;
volcri=zeros(rows(vv1),cols(vv1));
volcri1 = zeros(rows(vv1),cols(vv1));
volcri2 = zeros(rows(vv1),cols(vv1));
crr = 1;

do until crr>rows(volcri1);
  if aa1==aa2;
  volcri1[crr,.]=vv1[crr,.]; volcri2[crr,.]=vv3[crr,.];
   else;
  volcri1[crr,.] = lint(abs(dhat1)*100,vv1[crr,.]|vv2[crr,.],abs(aa1)|abs(aa2));
  volcri2[crr,.] = lint(abs(dhat1)*100,vv3[crr,.]|vv4[crr,.],abs(aa1)|abs(aa2));
endif;
crr=crr+1;
endo;

crr=1;
do until crr>rows(volcri);
volcri[crr,.]=lint(h,volcri1[crr,.]|volcri2[crr,.],hor[indh indh+1]);
crr=crr+1;
endo;

endif;
a1b=fstage2(abs(dhat1),2*a,_k[kk]/200);
{cib}=unitci(aat[2,1],1-a1b,cvdf_a);
/*cic=floor(cib*10)/10;*/

cic=floor(cib);

jjj=1;
do until jjj>rows(cic);
if cic[jjj]<minc(cc);
cic[jjj]=minc(cc);
elseif cic[jjj]>maxc(cc);
cic[jjj]=maxc(cc);
endif;
jjj=jjj+1;
endo;



volcri=volcri[.,2:cols(volcri)];/**/
/*volcri[2:rows(volcri),.]=volcri[2:rows(volcri),.]*sqrt(700);*/
/*volcri=volcri[.,(nmcic[1]-1)*7+1:nmcic[2]*7];*/

/*volcri=volcri[(nmcic[1]-1)*rows(_kall)+1:nmcic[2]*rows(_kall),.];*/
  if volktype$=="bonfadj";
   nmcic=indnvnew(cic,cc);
/*nmcic=indnvle(cic,cc);*/
   volcri=volcri[.,nmcic[1]:nmcic[2]];/**/
  elseif volktype$=="sup";
  nmsup=indnvle(ccvolk,cc);
   volcri=volcri[.,nmsup];
  endif;
/****************create longlagged or longhor data************************/

/*xtlhor = mkkrep(xt[.,i],rows(_k[kk]));*/
ytlhor = mkyk(yt[.,i],_k[kk]);


for iii (1, rows(_k[kk]),1);

xyprilh = packr(ytlhor[.,iii]~xt[.,i]);

/*remove missing values*/

yylh = xyprilh[.,1];
xxlh = xyprilh[.,2];

{ namlh,mlh,blh,stblh,vclh,stdlh,siglh,cxlh,rsqlh,residlh,dbwlh } = ols(0,yylh,xxlh); 
tblh[iii,i] = blh[2]/stdlh[2];

endfor;  /* for iii loop*/


endfor;  /* for i loop*/

/**********1.2 test using sup_bounds l-h test from volkanov
**********************************************************/
n = strtof(T);
/*tolsvalk = tbols/sqrt(rows(xt)); valkanov rescale statistics*/
/*tolsvalk = tblh/sqrt(n);*/
tolsvalk=tblh;
/**/
cribounds = zeros(2,1);

/******multi horizons*********************************/
/*
for hor (1, rows(_k), 1);
  
   sel = volcri[1,.].==_k[hor];
   crinew = delif(volcri', 1-sel');
   crinew = maxc(crinew[.,6])|minc(crinew[.,3]);
   crinew=sortc((dhat1/-abs(dhat1)).*crinew,1);
   cribounds = cribounds~crinew;
endfor;

volleft = tolsvalk'.< cribounds[1,2:cols(cribounds)];
volright = tolsvalk'.>cribounds[2,2:cols(cribounds)];
*/

/********only short horizon*****************/
/************************
cribtemp=maxc(volcri[.,38])|minc(volcri[.,6]);
cribounds=sortc((dhat1/abs(dhat1)).*cribtemp,1);
volleft = tolsvalk'.< cribounds[1];
volright = tolsvalk'.>cribounds[2];
*******************/

/*********************************************************/


if _k[kk]==1;
  if h1$=="two sided";
/*cribtemp=maxc(volcri[6,.]')|minc(volcri[3,.]');*/
cribtemp=maxc(volcri[37,.]')|minc(volcri[5,.]');
  else;
crittemp=maxc(volcri[5,.]')|minc(volcri[4,.]');
  endif;
cribounds=sortc((dhat1/abs(dhat1)).*cribtemp,1);
volleft = tolsvalk'.< cribounds[1];
volright = tolsvalk'.>cribounds[2];
else;
tolsvalklh=tolsvalk/sqrt(n);
volcrilh=volcri/sqrt(1000);

  if h1$=="two sided";
/*cribtemp=maxc(volcrilh[6,.]')|minc(volcrilh[3,.]');*/
cribtemp=maxc(volcrilh[37,.]')|minc(volcrilh[5,.]');
  else;
crittemp=maxc(volcrilh[5,.]')|minc(volcrilh[4,.]');
  endif;
cribounds=sortc((dhat1/abs(dhat1)).*cribtemp,1);
volleft = tolsvalklh'.< cribounds[1];
volright = tolsvalklh'.>cribounds[2];
endif;

if h1$=="two sided";
pvolk = (sumc(volleft) + sumc(volright))/cols(tolsvalk);
elseif h1$=="left sided";
pvolk=sumc(volleft)/cols(tolsvalk);
elseif h1$=="right sided";
pvolk=sumc(volright)/cols(tolsvalk);
endif;

fill=pvolk;   

/******************************************************
**   use ces critical values and laged regression
**********************************************************/

elseif test[tt]$=="ces";
  volktype="bonfadj";  /*choices are sup, bonfadj*/
for i (1,cols(tbols),1);

  
/**** select the right critical value matrix*******/
maxp = 10;  /* largest lag in BIC in first stage*/
/*cim = (0.99-1)*strtof(T);*/
xlag=mkkpslx(xt[.,i],_k[kk]);
xylag=packr(yt[.,i]~xlag);
{pstar,junk}=urbic(xylag[.,2],1,maxp+1);
{aat,junk}=adf(xylag[.,2],1,pstar);

{cim}=unitci(aat[2,1],0.0,cvdf_a);
_olsres=1;
{ vnam,m,b,stb,vc,stderr,sigma,cx,rsq,resid,dwstat } 
= ols(0,xylag[.,1],xylag[.,2]);

r1 = xylag[2:rows(xylag),2]-(1+cim[1]/strtof(T))*xylag[1:rows(xylag)-1,2];
r2 = resid[1:rows(resid)-1]; 

{dhat,omega}=deltahat(r1,r2,1,rows(r2),maxp);
dhat=dhat[1,2];
dhat1=dhat;

/*---select and interpolate to get cv's-----*/
/* here we select the correct critical value matrices depending on delta
  and interpolate */

if dhat<=-0.95;aa1=-95;aa2=-95;dhat=10;
elseif dhat<-0.9;aa1=-95;aa2=-90;dhat=10;
elseif dhat<-0.8;aa1=-90;aa2=-80;dhat=10;
elseif dhat<-0.7;aa1=-80;aa2=-70;dhat=10;
elseif dhat<-0.6;aa1=-70;aa2=-60;dhat=10;
elseif dhat<-0.5;aa1=-60;aa2=-50;dhat=10;
elseif dhat<-0.4;aa1=-50;aa2=-40;dhat=10;
elseif dhat<-0.3;aa1=-40;aa2=-30;dhat=10;
elseif dhat<-0.2;aa1=-30;aa2=-20;dhat=10;
elseif dhat<-0.1;aa1=-20;aa2=-10;dhat=10;
elseif dhat<0;aa1=-10;aa2=0;dhat=10;/**/
elseif dhat<0.1;aa1=0;aa2=10;dhat=10;
elseif dhat<0.2;aa1=10;aa2=20;dhat=10;
elseif dhat<0.3;aa1=20;aa2=30;dhat=10;
elseif dhat<0.4;aa1=30;aa2=40;dhat=10;
elseif dhat<0.5;aa1=40;aa2=50;dhat=10;
elseif dhat<0.6;aa1=50;aa2=60;dhat=10;
elseif dhat<0.7;aa1=60;aa2=70;dhat=10;
elseif dhat<0.8;aa1=70;aa2=80;dhat=10;
elseif dhat<0.9;aa1=80;aa2=90;dhat=10;
elseif dhat<0.95;aa1=90;aa2=95;dhat=10;
else; aa1=95;aa2=95;
endif;


/*    if _k[kk]==1;*/
    
/*
fomat1 = "d:/cowork2/longhor/fmtall/ces3/"$+ftos(abs(aa1),"ces3_%*.*lf",1,0);
fomat2 = "d:/cowork2/longhor/fmtall/ces3/"$+ftos(abs(aa2),"ces3_%*.*lf",1,0);
*/
/*
fomat1 = "d:/cowork2/longhor/fmt700/"$+ftos(aa1,"volkcri%*.*lf",1,0);
fomat2 = "d:/cowork2/longhor/fmt700/"$+ftos(aa2,"volkcri%*.*lf",1,0);
*/
/*
fomat1 = "d:/cowork2/longhor/fmt1000trend/"$+ftos(abs(aa1),"volkcri%*.*lf",1,0);
fomat2 = "d:/cowork2/longhor/fmt1000trend/"$+ftos(abs(aa2),"volkcri%*.*lf",1,0);
*/
fomat1 = "fmtall/fmt1000/"$+ftos(abs(aa1),"volkcri%*.*lf",1,0)$+ftos(1,"_%*.*lf",1,0);
fomat2 = "fmtall/fmt1000/"$+ftos(abs(aa2),"volkcri%*.*lf",1,0)$+ftos(1,"_%*.*lf",1,0);

/*
fomat1 = "d:/cowork2/longhor/fmt1h/"$+ftos(abs(aa1),"volkcri_%*.*lf",1,0);
fomat2 = "d:/cowork2/longhor/fmt1h/"$+ftos(abs(aa2),"volkcri_%*.*lf",1,0);
*/

load vv1 = ^fomat1;
load vv2 = ^fomat2;

volcri = zeros(rows(vv1),cols(vv1));
crr = 1;

do until crr>rows(volcri);
  if aa1==aa2;
  volcri[crr,.]=vv1[crr,.];
  else;

  volcri[crr,.] = lint(abs(dhat1)*100,vv1[crr,.]|vv2[crr,.],abs(aa1)|abs(aa2));

    endif;
crr=crr+1;
endo;
a1b=fstage(abs(dhat1),2*a);
{cib}=unitci(aat[2,1],1-a1b,cvdf_a);
/*cic=floor(cib*10)/10;*/

cic=floor(cib);

jjj=1;
do until jjj>rows(cic);
if cic[jjj]<minc(cc);
cic[jjj]=minc(cc);
elseif cic[jjj]>maxc(cc);
cic[jjj]=maxc(cc);
endif;
jjj=jjj+1;
endo;

nmcic=indnvnew(cic,cc);
/*nmcic=indnvle(cic,cc);*/

volcri=volcri[.,2:cols(volcri)];/**/


  if volktype$=="bonfadj";
   /*volcri=volcri[nmcic[1]:nmcic[2],.];  if use ces.fmt files*/
   volcri=volcri[.,nmcic[1]:nmcic[2]];
  elseif volktype$=="sup";
   volcri=volcri;
  endif;

for iii (1, rows(_k[kk]),1);


tblh[iii,i] = b[2]/stderr[2];

endfor;  /* for iii loop*/


endfor;  /* for i loop*/

/**********1.2 test using sup_bounds l-h test from volkanov
**********************************************************/
n = strtof(T);
/*tolsvalk = tbols/sqrt(rows(xt)); valkanov rescale statistics*/
/*tolsvalk = tblh/sqrt(n);*/
tolsvalk=tblh;
/**/
cribounds = zeros(2,1);

/******multi horizons*********************************/
/*
for hor (1, rows(_k), 1);
  
   sel = volcri[1,.].==_k[hor];
   crinew = delif(volcri', 1-sel');
   crinew = maxc(crinew[.,6])|minc(crinew[.,3]);
   crinew=sortc((dhat1/-abs(dhat1)).*crinew,1);
   cribounds = cribounds~crinew;
endfor;

volleft = tolsvalk'.< cribounds[1,2:cols(cribounds)];
volright = tolsvalk'.>cribounds[2,2:cols(cribounds)];
*/

/********only short horizon*****************/
/************************
cribtemp=maxc(volcri[.,38])|minc(volcri[.,6]);
cribounds=sortc((dhat1/abs(dhat1)).*cribtemp,1);
volleft = tolsvalk'.< cribounds[1];
volright = tolsvalk'.>cribounds[2];
*******************/

/*********************************************************/

  if h1$=="two sided";
  /*cribtemp=maxc(volcri[.,37])|minc(volcri[.,5]);  if use ces.fmt files */
   cribtemp=maxc(volcri[37,.]')|minc(volcri[5,.]');
  else;
  cribtemp=maxc(volcri[5,.]')|minc(volcri[4,.]');
  endif;
cribounds=sortc((dhat1/abs(dhat1)).*cribtemp,1);
volleft = tolsvalk'.< cribounds[1];
volright = tolsvalk'.>cribounds[2];


    if h1$=="two sided";
    pces = (sumc(volleft) + sumc(volright))/cols(tolsvalk);
    elseif h1$=="left sided";
    pces=sumc(volleft)/cols(tolsvalk);
    elseif h1$=="right sided";
    pces=sumc(volright)/cols(tolsvalk);
    endif; 


   fill=pces;

/**************************************************************************/
   elseif test[tt]$=="longhor";

   for i (1,cols(tbhac),1);
   ytlh=mkyk(yt[.,i],_k[kk]);

   xyprilh=packr(ytlh~xt[.,i]);

   yylh=xyprilh[.,1];
   xxlh=xyprilh[.,2];

   _m=_k[kk]-1;
   stdlh=hacreg(xxlh,yylh,_m,"nw");
   tbhac[1,i]=stdlh[3,1];
   endfor; /*for i loop */

    phac=meanc(abs(tbhac').>abs(tcri));
   fill=phac;

   elseif test[tt]$=="standols";  /*if test is trueDGP*/

for i (1,cols(tbols),1);

xtlag = mkkpslx(xt[.,i],_k[kk]);
ytlag = mkkrep(yt[.,i],rows(_k[kk]));
/**/

for iii (1, rows(_k[kk]),1);


xyprime = packr(ytlag[.,iii]~xtlag[.,iii]);

yy = xyprime[.,1];
xx = xyprime[.,2];

   if rows(xx)==strtof(T)-_k[kk]+1;
   else;
   "mkproc throw away too many observations";
   end;
   endif;

{ nam,m,b,stb,vc,std,sig,cx,rsq,resid,dbw } = ols(0,yy,xx); 
tbols[iii,i] = b[2]/std[2];/**/

endfor; /*for loop iii*/
endfor; /*for loop i*/
/**/
/**/

/**********1. standard asym test*************************/
cols1 = abs(tbols) .> abs(tcri); /*two sided ols test*/
pols1 = sumc(cols1')/cols(xt); 

fill=pols1;
/*******************************************************/
@@
  elseif test[tt]$=="trueDGP";  /*if test is trueDGP*/

for i (1,cols(tbols),1);

xtlag = mkkpslx(xt[.,i],_k[kk]);
ytlag = mkkrep(yt[.,i],rows(_k[kk]));
/**/

for iii (1, rows(_k[kk]),1);


xyprime = packr(ytlag[.,iii]~xtlag[.,iii]);

yy = xyprime[.,1];
xx = xyprime[.,2];

if rows(xx)==strtof(T)-_k[kk]+1;
   else;
   "mkproc throw away too many observations";
   end;
   endif;

{ nam,m,b,stb,vc,std,sig,cx,rsq,resid,dbw } = ols(0,yy,xx); 
tbols[iii,i] = b[2]/std[2];/**/

endfor; /*for loop iii*/
endfor; /*for loop i*/
/***********1.5 corrected size test using the true DGP*******/

/******this block calculate Mankiw and Shapiro (1985) critical values
************************************************************/
yh0 = yt - coeff[predit[aa]+1].*xt;
xh0 = xt;
a0 = 2*a;
taubound0 = sizecorr(yh0,xh0,a0,_k[kk]);
ph01 = sumc((abs(tbols).> taubound0)')/cols(tbols);

fill=ph01;


/************************************************************
*************************************************************/

elseif test[tt]$=="extremreg";

for i (1,cols(tbols),1);

xtlag = mkkpslx(xt[.,i],_k[kk]);
ytlag = mkkrep(yt[.,i],rows(_k[kk]));
/**/

for iii (1, rows(_k[kk]),1);


xyprime = packr(ytlag[.,iii]~xtlag[.,iii]);

yy = xyprime[.,1];
xx = xyprime[.,2];

if rows(xx)==strtof(T)-_k[kk]+1;
   else;
   "mkproc throw away too many observations";
   end;
   endif;

{ nam,m,b,stb,vc,std,sig,cx,rsq,resid,dbw } = ols(0,yy,xx); 
tbols[iii,i] = b[2]/std[2];/**/

endfor; /*for loop iii*/
endfor; /*for loop i*/
/***********2. corrected size test using delt = 0.9999 and persis = 0.9999*****/

/*******************************
this block use Mankiw and Shapiro critical values
***************************************************************************/
load ymcon = sizecorrected9999/yt099200.fmt; /* this is the controlled data, used for generate the adjusted distribution of tstat*/
load xmcon = sizecorrected9999/xt099200.fmt;  /*xt099 are data with delt = 0.9999, xt_099 are data w/ delt = -0.9999*/
ytcon = ymcon[2:rows(ymcon),subbeg:subn];
xtcon = xmcon[1:rows(xmcon)-1,subbeg:subn];

a1 = 2*a;
taubound = sizecorr(ytcon,xtcon,a1,_k[kk]);
pcon1 = sumc((abs(tbols).> taubound)')/cols(tbols);

fill=pcon1;


/****************************************************
in this block we use the alpha/2 one-sided test case***************************/ 
@
load ymcon = d:/cowork2/longhor/fmt/sizecorrected9999/yt099200.fmt; /* this is the controlled data, used for generate the adjusted distribution of tstat*/
load xmcon = d:/cowork2/longhor/fmt/sizecorrected9999/xt099200.fmt;  /*xt099 are data with delt = 0.9999, xt_099 are data w/ delt = -0.9999*/
ytcon = ymcon[2:rows(ymcon),1:1000];
xtcon = xmcon[1:rows(xmcon)-1,1:1000];
tbolscon = zeros(rows(_k),cols(xtcon));
for i (1,cols(tbolscon),1);
if spec $== "longlag";

ytconlag = mkkrep(ytcon[.,i],rows(_k));
xtconlag = mkkpslx(xtcon[.,i],_k);
else;

ytconlag = ytcon[.,i];
xtconlag = xtcon[.,i];

endif;

for iii (1, rows(_k),1);

xyprime = packr(ytconlag[.,iii]~xtconlag[.,iii]);
/*remove missing values*/
yy = xyprime[.,1];
xx = xyprime[.,2];

{ nam1,m1,b1,stb1,vc1,std1,sig1,cx1,rsq1,resid1,dbw1 } = ols(0,yy,xx); 
cls;
tbolscon[iii,i] = b1[2]/std1[2];
endfor;
endfor;
quant = {0.025,0.05,0.95,0.975};
tcricon = quantile(tbolscon', quant);


load tcricon1 = d:/cowork2/longhor/fmt/sizecorrected9999/tcricon200_5.fmt;
load tcricon2 = d:/cowork2/longhor/fmt/sizecorrected9999/tcricon200_5.fmt;
ccon1 = tbols' .< tcricon1[1,.]; 
ccon2 = tbols' .> tcricon2[4,.]; /*two sided corrected test*/

pcon1 = sumc(ccon1 + ccon2)/cols(xt); 
@
/********************************************************************************/

elseif test[tt]$=="sign";

/************Sign test***********************/
ns = cols(xt);

pv = zeros(ns,rows(_k[kk]));

_m = zeros(rows(_k[kk]),1);
for ii (1,ns,1);

ytsglag = mkkrep(yt[.,ii],rows(_k[kk]));
xtsglag = mkkpslx(xt[.,ii],_k[kk]);

ret = sign1(xtsglag,ytsglag);

pv[ii,.] = ret[3,.];

endfor;

rej = pv .< 0.025;
sgrej = sumc(rej)/ns;

fill=sgrej;

elseif test[tt]$=="signrank";

ns = cols(xt);
pvr = zeros(ns, rows(_k[kk]));
_m = zeros(rows(_k[kk]),1);
for ii (1,ns,1);

ytsglag = mkkrep(yt[.,ii],rows(_k[kk]));
xtsglag = mkkpslx(xt[.,ii],_k[kk]);

ret2 = signrnk1(xtsglag,ytsglag); /* sign rank test*/

pvr[ii,.] = ret2;
endfor;

rejr = pvr .< 0.025;
srgrej = sumc(rejr)/ns;

fill=srgrej;
/*******************************************************/





 else;
"no such a test proc";
end;
endif;
/*******save the results****************************/



@--------------------------
pval = _k~pvolk;
/*pval1 = pval1|pval;*/


/*svname = dirname $+ "pvaluesnew";*/
/*save path = ^svname pval1;*/


/*svname = dirname $+ "sizecorrected9999"; save the critical values for sizecorrected distribution. */
/*save path = ^svname tcricon;*/
/*endfor;
endfor;*/
if _prin;

print ftos(delt[j],"crosscorr:     %*.*lf",5,2);;
print ftos(persis[jj],"     autocorr:     %*.*lf",5,3);

print "Sample size:    ";;
print T;;
print ftos(cols(tbols),"     # of simul:    %*.*lf",5,0);

print ftos(coeff[predit[aa]+1],"True beta:     %*.*lf",5,3);
/*
print ftos(delt[j],"  \\delta:  %*.*lf",5,2);;
print ftos(persis[jj],"  \\rho:  %*.*lf",5,2);
*/
/*print "       hor     Asymp      Bonf     Speci     Model      Sign     SignR";*/
print "       hor      Bonf";
print "-------------------------------------------------"\
  "----------------";
format /m1 /rdn 10,4;
print pval;
/*print _k~pols1~pvolk~ph01~pcon1~sgrej~srgrej;*/
te = time;
cls;
spell = te-tb;
else;
endif;
clear pval;
----------------------------------------------------@

endfor; /*for aa */
pfill1 = pfill1~fill;

endfor; /* for j */
pfill2=pfill2|pfill1;
endfor; /* for jj */

print "test procedure:   ";;
print test[tt];;
print "    Horizon:   ";;
print _k[kk];
print "Alternative:   ";;
print h1;
print "Model:   ";; print model;
print "  delt/rho       0.4     0.5      0.7     0.9";
print "-------------------------------------------------------------";
format /m1 /rdn 10,4;
print pfill2[2:rows(pfill2),.];
kk=kk+1;
endo; /*for kk loop*/

tt=tt+1;
endo;
end;

/****** sign1 *******
sign1:  simple sign tests
y_k     : matrix of k period returns. Each col. corresponds
          to a k value in _k. entry i,j is given by
	  lrd_{t+1}+...+lrd_{t+_k_{j}}
	  Note: y_k will have some missing values towards the top 
x       : matrix of regressor (one col. of x for each col. of y_k (no constant included))
output:   
res     : 3 by rows(_m) matrix of regression output. Each column is output for 1 regression
          including  100*Sg/n| 100*se/n|p-val, where  100*Sg/n is percent of correctly signed 
          predictions, 100*se/n is the standard, p-val is the two sided p-value
********/

proc sign1(_x,y_k);
local xx,yy,iT,b,S,tb,R2,u,m,datai,_xy,res;  
local xdm,ydm,Sg,n,se,pr;
if rows(_m) == cols(y_k) and cols(y_k) == cols(_x);
else;
   "sign1: Error: rows(_m) NOT= cols(y_k) or cols(y_k) NOT= cols(x)";
  end;
endif;
res=zeros(3,rows(_m));   /*save res=results*/
datai = 1;
do until datai>rows(_m);
  _xy = packr(_x[.,datai]~y_k[.,datai]); 
  @Remove missing values. Note: series are column by column.@
 /*_xy = _x~y_k[.,1];*/
  xx = _xy[.,1];   
  yy = _xy[.,2];
  m = _m[datai];
  iT= rows(yy);
  /*xdm = xx-median(xx);*/
 /* ydm = yy;*/
  ydm = yy-median(yy);
  xdm = med2(xx); @removes the median of x using only past x@
 /* ydm = med2(yy); original */
  
 {Sg,n,se,pr} = signstat(ydm,xdm,0);
  res[.,datai]= 100*Sg/n| 100*se/n|pr;
  datai = datai+1;
endo;
retp(res);
endp;
@***********@


proc signrnk1(_x,y_k);
local xx,yy,iT,b,S,tb,R2,u,m,datai,_xy,res;  
local xdm, ydm,Srg,n,se,pr;
if rows(_m) == cols(y_k) and cols(y_k) == cols(_x);
else;
   "sign1: Error: rows(_m) NOT= cols(y_k) or cols(y_k) NOT= cols(x)";
  end;
endif;
res=zeros(1,rows(_m)); @save res=results@
datai = 1;
do until datai>rows(_m);
  _xy = packr(_x[.,datai]~y_k[.,datai]);  
  @Remove missing values. Note: series are column by column.@
 /* _xy = _x~y_k[.,1];*/
  xx = _xy[.,1];   
  yy = _xy[.,2];
  m = _m[datai];
  iT= rows(yy);
  /*xdm = xx-median(xx);*/
  /*ydm = yy;*/
  ydm = yy-median(yy);
  xdm = med2(xx); @removes the median of x using only past x@
 /* ydm = med2(yy); original */
 {Srg} = signrank(ydm,xdm,0);
  
  /*res[.,datai]= 100*Sg/n| 100*se/n|pr;*/
  
  n = rows(xdm);
  local pv;
  if Srg < n*(n+1)/4;
  pv = cdfn((Srg - n*(n+1)/4)/sqrt(n*(n+1)*(2*n+1)/24));
  else;
  pv = 1-cdfn((Srg - n*(n+1)/4)/sqrt(n*(n+1)*(2*n+1)/24));
  endif;
  res[.,datai] = pv;
  datai = datai+1;
endo;
retp(res);
endp;
@***********@


/***mkkrep: make k repitions ****
inputs: y:       N by 1 data series
numrep:  number of repitions needed
output: ykrep:   N by numrep Matrix. 
All columns are equal to y, which has been repeated numrep times
*****/		 
proc(1) = mkkrep(y,numrep);
local r,ykrep;
ykrep = y;
r = 2;
do until r>numrep;
  ykrep = ykrep~y;
  r =r+1;
endo;
retp(ykrep);
endp;


/****** hacreg *******
hackkern:  string of kernel in HAC estimation. Choices are:
            "nw" for Newey-West or "hh" for Hansen-Hodrick 
_m      : vector of bandwidths for HAC estimator (rows(_m) = cols(y_k<));
          Campbell sets _m to _k-1 where k is the vector of horizons
y_k     : matrix of k period returns. Each col. corresponds
          to a k value in _k. entry i,j is given by
	  lrd_{t+1}+...+lrd_{t+_k_{j}}
	  Note: y_k will have some missing values towards the top 
x       : matrix of regressor (one col. of x for each col. of y_k (no constant included))
output:   
res     : 3 by rows(_m) matrix of regression output. Each column is output for 1 regression
          including b|R2|tb, where tb is calculated using hac covariance. setting _m=0
	  gives standard (non-hac) t-statistic.
********/
proc hacreg(_x,y_k,_m,hackern);
local xx,yy,iT,b,S,tb,R2,u,m,datai,_xy,res;

if rows(_m) == cols(y_k) and cols(y_k) == cols(_x);
else;
   "lrheg: Error: rows(_m) NOT= cols(y_k) or cols(y_k) NOT= cols(x)";
  end;
endif;
res=zeros(3,rows(_m)); @save results@
datai = 1;
do until datai>rows(_m);
   
  _xy = packr(_x[.,datai]~y_k[.,datai]);  
  @Remove missing values. Note: series are column by column.@
  
  xx = _xy[.,1]; 
   
  yy = _xy[.,2];
  yy = yy - meanc(yy); @demean@
  xx = xx - meanc(xx); @demean@
  m = _m[datai];
  iT= rows(yy);
  b=inv(xx'xx)*xx'yy;
  u=yy-xx*b;
  if hackern $== "nw";
    S=hacnw(xx,u,m);
  elseif hackern $== "hh";
    S=hachh(xx,u,m);
  endif;
    tb=b./sqrt(diag(iT*inv(xx'xx)*S*inv(xx'xx)));
    R2 = (stdc(xx*b)/stdc(yy))^2; 
/*
" xxb ";; iscplx(xx*b);; imag(xx*b);
" xx ";; iscplx(xx);; imag(xx);
" b ";; iscplx(b);; imag(b);
wait;
*/

    if _m[datai] == 0; @Remove to replicate exactly for k=1@
      tb=b./sqrt(diag(inv(xx'xx)*1/(iT-2)*u'u ));
    endif; 
  res[.,datai]=b|R2|tb;
  datai = datai+1;
endo;
retp(res);
endp;
@***********@


/***** proc to calculate the size corrected critical value*****
imput: simulated xt-1 and yt, desired size level, and horizons
output: the absolute critical values giving the desired size level
***************************************************************/

proc(1) = sizecorr(y,x,alpha,_k);
local tbols,i,yt,xt,yy,xx,tau,s,frac,taubound,j,bound,xypack; 
local nam,m,b,stb,vc,std,sig,cx,rsq,resid,dbw;

bound = 0;
for j (1, rows(_k), 1);


tbols = zeros(1,cols(x));
for i (1,cols(tbols),1);

yt = y[.,i];
xt = mkkpslx(x[.,i],_k[j]);
xypack = packr(yt~xt);
yy = xypack[.,1];
xx = xypack[.,2];


{ nam,m,b,stb,vc,std,sig,cx,rsq,resid,dbw } = ols(0,yy,xx); 


tbols[1,i] = b[2]/std[2];
endfor;

tau = sortc(tbols',1);
if abs(tau[1])>=abs(tau[rows(tau)]);
for s (1, cols(tbols), 1);
taubound = abs(tau[s]);
frac = sumc((abs(tbols).>taubound)')/cols(tbols);
  if abs(frac-0.05) <= 1e-6; 
  break;
  endif;
endfor;

else;
for s (1, cols(tbols), 1);
taubound = abs(tau[rows(tau)+1-s]);
frac = sumc((abs(tbols).> taubound)')/cols(tbols);
  if abs(frac-0.05) <= 1e-6; 
  break;
  endif;
endfor;

endif;

bound = bound|taubound;
endfor;
retp(bound[2:rows(bound)]);
endp;

@***
mkyk: make k-period return (y) from one period return
inputs:
  _k: column vector or return horizons or length
  y: N by 1 column vector of returns
outputs:
  kpy: k-period returns
         An N by rows(_k) matrix
         kpy[t,j] = (y_{t+1})+...+y{t+_k[j]})
****@
proc(1) = mkyk(y,_k);
local yleads,y_k,kk,kpy;
@form k- period nominal log return@
yleads = miss(zeros(rows(y),maxc(_k)),0); @cols are y_{k+1},lrd_{k+2},...,y_{t+masc(_k)@
y_k =  miss(zeros(rows(y),rows(_k)),0); @matrix of k period returns. Each col. corresponds
                                           to a k value in _k. entry i,j is given by
					   y_{t+1}+...+y_{t+_k_{j}}@



kk =1;
do until kk>maxc(_k);
  yleads[1:rows(y)-kk+1,kk] = y[1+kk-1:rows(y)];  
  kk=kk+1;
endo;
kk =1;
do until kk>rows(_k);
  y_k[.,kk] = sumc(yleads[.,1:_k[kk]]');
  kk=kk+1;
endo;
kpy = y_k;

retp(kpy);
endp;
@**************@

 




